;	Static Name Aliases
;
	TITLE   zpasm.c
	NAME    zpasm

	.8087
ZPASM_TEXT	SEGMENT  WORD PUBLIC 'CODE'
ZPASM_TEXT	ENDS
_DATA	SEGMENT  WORD PUBLIC 'DATA'
_DATA	ENDS
CONST	SEGMENT  WORD PUBLIC 'CONST'
CONST	ENDS
_BSS	SEGMENT  WORD PUBLIC 'BSS'
_BSS	ENDS
DGROUP	GROUP	CONST, _BSS, _DATA
	ASSUME  CS: ZPASM_TEXT, DS: DGROUP, SS: DGROUP
EXTRN	__acrtused:ABS
EXTRN	_inp:FAR
EXTRN	_outp:FAR
COMM 	_epci_stat:	BYTE:	 2
EXTRN	_port:WORD
_DATA      SEGMENT
_DATA      ENDS
ZPASM_TEXT      SEGMENT
	ASSUME	CS: ZPASM_TEXT
;|*** #include <conio.h>
;|*** 
;|*** 
;|*** int epci_stat;
;|*** extern int port;
;|*** 
;|*** int rcv_pkt(int pktlen, char *buf)	/* Returns -1 if error */
;|*** {

CHARTIME EQU -1

	PUBLIC	_rcv_pkt
_rcv_pkt	PROC FAR
	push	bp
	mov	bp,sp
	sub	sp,6
	push	di
	push	si
	push	dx			; Used DX -- wl
;	pktlen = 6
;	buf = 8
;	register si = p
;	register di = count
;	timeout = -4
;|***   register char *p;
;|***   register int count;
;|***   int timeout;				/* If this counts down to 0, time out */
;|*** 
;|*** 	count = pktlen;
	mov	di,WORD PTR [bp+6]	;pktlen
					;|*** 	p = buf;
	mov	si,WORD PTR [bp+8]	;buf
					;|*** 	timeout=CHARTIME;
	mov	WORD PTR [bp-4],CHARTIME	;timeout
					;|*** 	do
$D122:
	mov	dx,_port		; Status at port+1
	inc	dx
	in	al,dx

	test	al,48			; Check for communications error
	jnz	$I125			; (Bit set if error)

	test	al,2			; Check for character present
	je	$I126			; (Bit set if present)

	dec	dx			; DX = _port
	in	al,dx
	mov	BYTE PTR [si],al
	inc	si
					;|*** 	        count--;		/* Receive character & decr. count */
	dec	di
					;|*** 		timeout=CHARTIME;	/* Restart countdown timer */
	mov	WORD PTR [bp-4],CHARTIME	;timeout
	jmp	$D122			;Get another character

$I125:	mov	al,21			; Reset comm port error bits
	mov	dx,_port
	add	dx,3			; output to _port+3
	out	dx,al
	mov	ax,-2			; Return -2 to show error
	jmp	$I129

$I126:	dec	WORD PTR [bp-4]		; Count the timer down
	jz	$D128			; If it reaches 0, bug out
	or	di,di			; If character count > 0,
	jg	$D122			;  continue to rcv chars

$D128:
					;|*** 	return (timeout==0);		/* Return -1 if counted down to 0 */
	cmp	WORD PTR [bp-4],1	;timeout
	sbb	ax,ax
	neg	ax
$I129:	pop	dx			; used DX -- wl
	pop	si
	pop	di
	mov	sp,bp
	pop	bp
	ret	
	nop	

_rcv_pkt	ENDP
ZPASM_TEXT	ENDS
END
					;|*** }
